
MemDump:
	mflr r0 			#;R0=LR
	stwu r0,-4(SP)		#;Push onto SP/R1
		mr r8,r3
		bl ShowHex32
		li r3,':'
		bl PrintChar
		bl NewLine
		
MemDumpNextLine:	
		li r7,8
MemDumpAgain:	
		lbz r3,0(r8)
		addi r8,r8,1
		bl ShowHex8
	
		li r3,' '
		bl PrintChar
	
		addi r7,r7,-1
		cmpwi r7,0
		bne MemDumpAgain
		
		addi r8,r8,-8
		
		li r7,8
MemDumpAgainB:	
		lbz r3,0(r8)
		addi r8,r8,1
		cmpwi r3,31
		blt MemDumpAgainNG
		cmpwi r3,128
		bgt MemDumpAgainNG
		
		
		b MemDumpAgainOk
MemDumpAgainNG:
		li r3,'.'
MemDumpAgainOk:		
		bl PrintChar
		
		addi r7,r7,-1
		cmpwi r7,0
		bne MemDumpAgainB
		
		
		bl NewLine
		
		addi r4,r4,-1
		cmpwi r4,0
		bne MemDumpNextLine
		
	lwzu r0,0(sp)		#;POP
	addi sp,sp,4		#;POP
	mtlr r0				#;LR=R0
	blr
	
	
	
Monitor:
	stwu r0,-4(SP)		#;Push R0 onto SP/R1

	mfcr r0 			#;R0=CR
	stwu r0,-4(SP)		#;Push CR onto SP/R1
	
	mflr r0 			#;R0=LR
	stwu r0,-4(SP)		#;Push LR onto SP/R1
				
		addi sp,sp,-128
		stmw r2,0(sp)		#;Store Multiple $2+
		
		
			
			lwz r3,128+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg
			
			
			mr r3,r1
			addi r3,r3,128+12
			;#li r4,' '
			li r5,'S'
			li r6,'P'
			bl ShowReg
			
			
			mr r3,r2
			li r4,'T'
			li r5,'O'
			li r6,'C'
			bl ShowReg
			
			bl NewLine

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,7			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			li r4,'R'
			li r5,'1'
			li r6,'0'
			li r8,10			#;Count
			li r9,2
			bl ShowRegs
			
			li r5,'2'
			li r6,'0'
			li r8,10			#;Count
			li r9,1
			bl ShowRegs
			
			li r5,'3'
			li r6,'0'
			li r8,2			#;Count
			li r9,3
			bl ShowRegs
			
			lwz r3,128(sp)
			li r4,' '
			li r5,'L'
			li r6,'R'
			li r8,2			#;Count
			li r9,3
			bl ShowReg
			
			bl NewLine
			
			mfctr r3
			li r4,'C'
			li r5,'T'
			#;li r6,'R'
			bl ShowReg
			
			mfxer r3
			li r4,'X'
			li r5,'E'
			#;li r6,'R'
			bl ShowReg
			
			lwz r3,128+4(sp)
			li r4,' '
			li r5,'C'
			#;li r6,'R'
			bl ShowReg
		
			bl NewLine
				
		lmw r2,0(sp)
		addi sp,sp,128
	
	lwzu r0,0(sp)		#;POP LR
	addi sp,sp,4		#;POP
	mtlr r0				#;R0=LR
	
	lwzu r0,0(sp)		#;POP R0
	addi sp,sp,4		#;POP
	mtcrf 0xFF,r0		#;R0=CR
	
	lwzu r0,0(sp)		#;POP R0
	addi sp,sp,4		#;POP
	blr
		
	
ShowRegs:	#; R4R5R6: (R7) * R8

	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
		
ShowRegsAgain:		
		mr r3,r4
		bl PrintChar
		mr r3,r5
		bl PrintChar
		mr r3,r6
		bl PrintChar
		li r3,':'
		bl PrintChar
		
		lwz r3,0(r7)
		addi r7,r7,4
		bl ShowHex32			#;Show R3 as HEX	
		
		li r3,' '
		bl PrintChar
		
		addi r6,r6,1
		
		addi r9,r9,-1
		cmpwi r9,0
		bne ShowRegsAgainNNL
		
		bl NewLine
		li r9,3
ShowRegsAgainNNL:	
		addi r8,r8,-1
		cmpwi r8,0
		bne ShowRegsAgain
		
	
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	
	blr
	
	
ShowReg:	#; R4R5R6: R3 

	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
		mr r7,r3
		
		mr r3,r4
		bl PrintChar
		mr r3,r5
		bl PrintChar
		mr r3,r6
		bl PrintChar
		li r3,':'
		bl PrintChar
		
		mr r3,r7
		bl ShowHex32			#;Show R3 as HEX	
			
		li r3,' '
		bl PrintChar
		
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	
	blr
	
	
ShowHex32:			#;Show R3 as HEX

	addi sp,sp,-128
	stmw r2,0(sp)

	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
		mr r4,r3
		li r6,8
ShowHexAgain:	
		
		andis. r3,r4,0xF000
		
		li r5,28
		srw r3,r3,r5
		
		addi r3,r3,'0'
		cmpwi r3,':'
		blt ShowHexOK
		addi r3,r3,7
ShowHexOK:
		bl PrintChar
		
		li r5,4
		slw r4,r4,r5
		
		addi r6,r6,-1
		cmpwi r6,0
		bne ShowHexAgain
		
		
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	
	
	lmw r2,0(sp)
	addi sp,sp,128
	
	blr
	
	
ShowHex8:			#;Show R3 as HEX

	addi sp,sp,-128
	stmw r2,0(sp)

	li r5,24
	slw r3,r3,r5
	
	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
	
		mr r4,r3
		li r6,2
ShowHex8Again:	
		
		andis. r3,r4,0xF000
		
		li r5,28
		srw r3,r3,r5
		
		addi r3,r3,'0'
		cmpwi r3,':'
		blt ShowHexOK
		addi r3,r3,7
ShowHex8OK:
		bl PrintChar
		
		li r5,4
		slw r4,r4,r5
		
		addi r6,r6,-1
		cmpwi r6,0
		bne ShowHex8Again
		
		
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
		
	lmw r2,0(sp)
	addi sp,sp,128
	
	blr
	