

	
PrintChar:		#;Print R3
	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
		
		addi sp,sp,-128
		stmw r2,0(sp)

			subi r3,r3,32 	#;No Char<Space
			slwi r3,r3,3	#;Char*8


			lis r11,MyFont@ha
			ori r11,r11,MyFont@l
			add r11,r11,r3

			lis     r8,-0x3FB0 #;0xC0500000 - XFB address
			
			lis r7,CharX@ha
			ori r7,r7,CharX@l
			
			lbz r4,0(r7)
			mulli r4,r4,4*8	#;Xpos *8 blocks
			add r8,r8,r4
			
			lbz r4,0(r7)
			addi r4,r4,1	#;Across 1 char
			stb r4,0(r7)
			

			lbz r4,1(r7)
			mulli r4,r4,0x5000	#;Ypos 1280*8 blocks
			add r8,r8,r4
			
			
			li 		r7,8	#;Y
PrintCharY:
			
			li 		r6,8	#;X
			mr 		r9,r6
			mr 		r10,r8
			
			lbz r4,0(r11)
			addi r11,r11,1
			
PrintCharX:	
			


		#;Yellow
			lis     r0,0xE200	#; YYBB
			ori     r0,r0,0xE294 #;  YYRR

			andi. r3,r4,0b10000000
			bne PrintCharDraw
			
			
	#;Blue
		lis     r0,0x00CF	#; YYBB
		ori     r0,r0,0x007b #;  YYRR
			
PrintCharDraw:	
			stw     r0,0(r8)	#;Line1
			stw     r0,1280(r8) #;Line 2 (Double height)
			
			slwi r4,r4,1
			
			
			addi r8,r8,4
			
			
			addi r6,r6,-1
			cmpwi   r6,0
			bne  PrintCharX
			
			mr 		r6,r9
			
			mr 		r8,r10
			addi r8,r8,1280*2		#;Down two lines
			
			addi r7,r7,-1
			cmpwi   r7,0
			bne  PrintCharY
			
			
		lmw r2,0(sp)
		addi sp,sp,128
	
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	
	blr

PrintString:
	mflr r0 			#;R0=LR
	stwu r0,-16(SP)		#;Push onto SP/R1
	
		mr r4,r3
PrintStringAgain:
		
		lbz r3,0(r4)		#;Get zero extended byte
		cmplwi r3,255
		beq PrintStringDone
		bl PrintChar
		addi r4,r4,1		#;Inc Pointer
		
		b PrintStringAgain
PrintStringDone:
	lwzu r0,0(sp)		#;POP
	addi sp,sp,16		#;POP
	mtlr r0				#;LR=R0
	blr	
	
	
	
NewLine:
	PushAll
				
		mr r0,r4
		lis r3,CharX@ha
		ori r3,r3,CharX@l
		
		li r4,0
		stb r4,0(r3)
		
		lis r3,CharY@ha
		ori r3,r3,CharY@l
		
		
		lbz r4,0(r3)
		addi r4,r4,1			#;Can't use R0 for some reason!
		stb r4,0(r3)
		
		mr r4,r0

	PopAll
	blr
	
	
CLS:
	lis     r8,-0x3FB0 #;0xC0500000 - XFB address

	lis r5,0x0002
	ori r5,r5,0x5800 #;0x25800=320*480
	
CLSb:
	stw     r3,0(r8)
	addi r8,r8,4
	
	addi r5,r5,-1
	cmpwi r5,0
	bne  CLSb
	blr	


.data
CharX: .byte 0
CharY: .byte 0

MyFont:
	.incbin "/ResAll/Font96.FNT"
.text
