
	.include "/SrcNGC/BasicHeader.asm"
	
	#;b LogicalOps
	#;b SignsAndZeros
	b Shifts
	
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
LogicalOps:
	lis r6,0x1234
	addi r6,r6,0x5678
	mr r3,r6
	mr r4,r6
	mr r5,r6
	
	li r0,0x0FF0
	
	bl Monitor6
	bl NewLine
	
	and r3,r6,r0				#;Logical AND
	andc r4,r6,r0 				#;AND with Complement
	andi. r5,r6,0xFF00			#;AND Immediate .=CR update
		
	bl Monitor6
	
	
	or r3,r6,r0					#;Logical OR
	orc r4,r6,r0 				#;OR with Complement
	oris r5,r6,0xFF00			#;OR Immediate Shifted 
		
	bl Monitor6
	
	
	xor r3,r6,r0				#;Logical XOR
	xori r4,r6,0xFF00			#;XOR Immediate
	xoris r5,r6,0xFF00			#;XOR Immediate Shifted

	bl Monitor6
	
	
	nand r3,r6,r0				#;R6 AND R0 Complemented
	
	bl Monitor6
	
	li r5,0x0FF
	li r0,0xFF0
	
	eqv r4,r5,r0				#;R6 XOR R0 Complemented
		
#;Logical XNOR (EQV) will return 1 when the contents
#; of rS and rB are the same, returning 0 if they are different,
#; effectively returning 1 (true) if the bits are equivalent.
		
	bl Monitor6
	
	bl NewLine
	
	not r3,r6					#;Bit flip  R3=!R6
	
	neg r4,r6					#;Negate	R4=-R6
	
	bl Monitor6
	
#; Note, options change depending on command	
	
#;xorc r4,r6,r0 				#;No such command
#;xoris. r5,r6,0xFF00			#;No such command
	
	b InfLoop
	
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SignsAndZeros:	
	li r0,0
	ori r3,r0,0xFECD
	ori r4,r0,0xFECD
			
	bl Monitor6
	
	extsb r3,r3					#;Extend Signed byte
	
	extsh r4,r4					#;Extend Signed Half
	
	bl Monitor6
	
	ori r3,r0,0x1234
	ori r4,r0,0x1234
	
	extsb r3,r3					#;Extend Signed byte
	
	extsh r4,r4					#;Extend Signed Half
	
	bl Monitor6
	
	cntlzw r5,r4				#;CouNT Leading Zeros in Word
	
	cntlzw r0,r3
	
	bl Monitor6
	
	b InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
Shifts:
	li r3,0x1234
	li r4,0x1234

	li r5,1				#; Shift
	li r0,5				#; Count=4
	bl Monitor345
	
	mtctr r0			
ShiftAgain:	
	
	slw r3,r3,r5		#;R3=R3 Shifted R5 bits
	slw. r4,r4,r5		#;R3=R3 Shifted R5 bits with CCR update
	
	bl Monitor345
	
	bdnz ShiftAgain
		
	bl NewLine
	
	lis r3,0x8765
	lis r4,0x8765

	li r5,1				#; Shift
	li r0,5				#; Count=4
	bl Monitor345
		
	mtctr r0			
ShiftAgain2:	
	
	srw r3,r3,r5	#;R3=R3 Shifted Right R5 bits (Unsigned)
	
	#;sraw r4,r4,r5	#;R3=R3 Shifted Right Algebraic R5 bits (Signed)
	srawi r4,r4,1	#;R3=R3 Shifted Right Algebraic Immediate bits (Signed)
		
	bl Monitor345
	
	bdnz ShiftAgain2
	
	
	bl NewLine


	lis r3,0x8765
	ori r3,r3,0x4321
	lis r4,0x8765
	ori r4,r4,0x4321

	li r5,1				#; Shift Left 1
	#;li r5,31			#; Shift Right 1
	li r0,5				#; Count=4
	bl Monitor345
		
	mtctr r0			
ShiftAgain3:	
	
	#;RLWNM Dest,Src,BitShift,FirstBitToKeep,LastBitToKeep
	
	rlwnm r3,r3,r5,16,31 	#;Rotate Left Word aNd Mask
	
	rlwinm r4,r4,1,8,16		#;Rotate Left Word Immediate aNd Mask
		
	bl Monitor345
	
	bdnz ShiftAgain3

	bl NewLine
	
		
	lis r3,0x8765
	ori r3,r3,0x4321
	lis r4,0xFFEE
	ori r4,r4,0xDDCC

	bl Monitor345
	
	#;RLWIMI Dest,Src,BitShift,FirstBitToKeep,LastBitToKeep
	
	rlwimi r3,r4,4,16,31 #;Rotate Left Word Immediate 4 and Mask Insert bits 15-31
	bl Monitor345

	rlwimi r3,r4,8,16,31 #;Rotate Left Word Immediate 4 and Mask Insert bits 15-31
	bl Monitor345
	
	rlwimi r3,r4,12,16,31 #;Rotate Left Word Immediate 4 and Mask Insert bits 15-31
	bl Monitor345
	
	#;28 = Rotate Right 4
	rlwimi r3,r4,28,16,31 #;Rotate Left Word Immediate 4 and Mask Insert bits 15-31
	bl Monitor345
			
			
	b InfLoop
	
#;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
	
	
InfLoop:	
	b       InfLoop

Monitor6:
	PushAll
		
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg
				
			mr r3,r1
			addi r3,r3,120+12
			;#li r4,' '
			li r5,'S'
			li r6,'P'
			bl ShowReg
			
			
			lwz r3,120+4(sp)
			#;li r4,' '
			li r5,'C'
			li r6,'R'
			bl ShowReg
			
			bl NewLine

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr
	

Monitor034:
	PushAll
		
			lwz r3,120+8(sp)
			li r4,' '
			li r5,'R'
			li r6,'0'
			bl ShowReg

			mr r7,sp
			addi r7,r7,4
			#;lwz r3,4(sp)
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,2			#;Count
			li r9,2			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	

Monitor345:
	PushAll
		
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,3			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
	PopAll
	blr	
	

Monitor345678:
	PushAll
		
			mr r7,sp
			addi r7,r7,4
			
			li r4,' '
			li r5,'R'
			li r6,'3'
			li r8,6			#;Count
			li r9,3			#;show on line
			bl ShowRegs
			
			bl NewLine
	PopAll
	blr	
	.include "/SrcNGC/BasicFooter.asm"

	
	
